package net.npaka.gestureex;
import java.util.ArrayList;
import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.view.GestureDetector;
import android.view.MotionEvent;
import android.view.View;

//WFX`[Cxg̏
public class GestureView extends View implements
    GestureDetector.OnGestureListener,
    GestureDetector.OnDoubleTapListener {
    private ArrayList<String> info;
    private GestureDetector gestureDetector;
    
    //RXgN^
    public GestureView(Context context) {
        super(context);
        setBackgroundColor(Color.WHITE);

        //̐
        info=new ArrayList<String>();
        info.add("GestureEx");
        
        //WFX`[fBeN^[̐(1)
        gestureDetector=new GestureDetector(context,this);

        //tH[JXw
        setFocusable(true);
    }
    
    //`掞ɌĂ΂
    @Override 
    protected void onDraw(Canvas canvas) {
        //`IuWFNg̐
        Paint paint=new Paint();
        paint.setAntiAlias(true);
        paint.setTextSize(24);
        
        //̕`
        for (int i=0;i<info.size();i++) {
            canvas.drawText((String)info.get(i),0,24+26*i,paint);
        }
    }
    
    //̒ǉ
    private void addInfo(String str) {
        info.add(0,str);
        while (info.size()>30) info.remove(info.size()-1);
        invalidate();
    }

    //^b`ɌĂ΂
    @Override
    public boolean onTouchEvent(MotionEvent event) {
        //WFX`[fBeN^[̐ݒu(2)
        gestureDetector.onTouchEvent(event);
        return true;
    }
    
    //_EɌĂ΂
    public boolean onDown(MotionEvent e) {
        addInfo("Down");
        return false;
    }

    //vXɌĂ΂(3)
    public void onShowPress(MotionEvent e) {
        addInfo("ShowPress");
    }
    
    //AbvɌĂ΂(3)
    public boolean onSingleTapUp(MotionEvent e) {
        addInfo("Up");
        return false;
    }
    
    //ɌĂ΂(3)
    public void onLongPress(MotionEvent e) {
        addInfo("LongPress");
    }

    //tbNɌĂ΂(3)
    public boolean onFling(MotionEvent e0,MotionEvent e1,
        float velocityX,float velocityY) {
        addInfo("Fling("+(int)velocityX+","+(int)velocityY+")");
        return false;
    }
    
    //XN[ɌĂ΂(3)
    public boolean onScroll(MotionEvent e0,MotionEvent e1,
        float distanceX,float distanceY) {
        addInfo("Scroll("+(int)distanceX+","+(int)distanceY+")");
        return false;
    }

    //VO^bvɌĂ΂(3)
    public boolean onSingleTapConfirmed(MotionEvent e) {
        addInfo("SingleTap");
        return false;
    }
    
    //_u^bvɌĂ΂(3)
    public boolean onDoubleTap(MotionEvent e) {
        addInfo("DoubleTap");
        return false;
    }

    //_u^bvCxgɌĂ΂(3)
    public boolean onDoubleTapEvent(MotionEvent e) {
        addInfo("DoubleTapEvent");
        return false;
    }
}