package net.npaka.sqliteex;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.ContentValues;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.graphics.Color;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;

//f[^x[X̓ǂݏ
public class SQLiteEx extends Activity 
    implements View.OnClickListener {
    private final static int WC=LinearLayout.LayoutParams.WRAP_CONTENT;
    private final static int FP=LinearLayout.LayoutParams.FILL_PARENT;
    private final static String DB_NAME ="test.db";//DB
    private final static String DB_TABLE="test";   //e[u
    private final static int    DB_VERSION=1;      //o[W
    
    private EditText       editText;//GfBbgeLXg
    private SQLiteDatabase db;      //f[^x[XIuWFNg
    
    //ANeBreBNɌĂ΂
    @Override
    public void onCreate(Bundle bundle) {
        super.onCreate(bundle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        //CAEg̐
        LinearLayout layout=new LinearLayout(this);
        layout.setBackgroundColor(Color.rgb(255,255,255));
        layout.setOrientation(LinearLayout.VERTICAL);
        setContentView(layout);              
        
        //GfBbgeLXg̐
        editText=new EditText(this);
        editText.setText("",EditText.BufferType.NORMAL);
        editText.setLayoutParams(new LinearLayout.LayoutParams(FP,WC));
        layout.addView(editText);

        //{^̐
        layout.addView(makeButton("","write"));
        layout.addView(makeButton("ǂݍ","read"));

        //f[^x[XIuWFNg̎擾(5)
        DBHelper dbHelper=new DBHelper(this);
        db=dbHelper.getWritableDatabase();
    }
    
    //{^̐
    private Button makeButton(String text,String tag) {
        Button button=new Button(this);
        button.setText(text);
        button.setTag(tag);
        button.setOnClickListener(this);
        button.setLayoutParams(new LinearLayout.LayoutParams(WC,WC));
        return button;
    }    

    //{^NbNCxg̏
    public void onClick(View v) {
        String tag=(String)v.getTag();
        //DBւ̏
        if (tag.equals("write")) {
            try {
                String str=editText.getText().toString();
                writeDB(str);                
            } catch (Exception e) {
                showDialog(this,"G[","ݎs܂ ");
            }
        } 
        //DB̓ǂݍ
        else if (tag.equals("read")) {
            try {
                String str=readDB();
                editText.setText(str);               
            } catch (Exception e) {
                showDialog(this,"G[","ǂݍݎs܂ ");
            }            
        }
    }    

    //f[^x[Xւ̏(6)
    private void writeDB(String info) throws Exception {
        ContentValues values=new ContentValues();
        values.put("id","0");
        values.put("info",info);
        int colNum=db.update(DB_TABLE,values,null,null);
        if (colNum==0) db.insert(DB_TABLE,"",values);
    }

    //f[^x[X̓ǂݍ(7)
    private String readDB() throws Exception {
        Cursor c=db.query(DB_TABLE,new String[]{"id","info"},
            "id='0'",null,null,null,null);
        if (c.getCount()==0) throw new Exception();
        c.moveToFirst();
        String str=c.getString(1);
        c.close();
        return str;
    }     
    
    //_CAO̕\
    private static void showDialog(Context context,String title,String text) {
        AlertDialog.Builder ad=new AlertDialog.Builder(context);
        ad.setTitle(title);
        ad.setMessage(text);
        ad.setPositiveButton("OK",null);
        ad.show();
    }
    
    //f[^x[Xwp[̒`(1)
    private static class DBHelper extends SQLiteOpenHelper {
        //f[^x[Xwp[̃RXgN^(2)
        public DBHelper(Context context) {
            super(context,DB_NAME,null,DB_VERSION);
        }
        
        //f[^x[X̐(3)
        @Override
        public void onCreate(SQLiteDatabase db) {
            db.execSQL("create table if not exists "+
                DB_TABLE+"(id text primary key,info text)");
        }

        //f[^x[X̃AbvO[h(4)
        @Override
        public void onUpgrade(SQLiteDatabase db,
            int oldVersion,int newVersion) {
            db.execSQL("drop talbe if exists "+DB_TABLE);
            onCreate(db);
        }
    }
}