package net.npaka.homeex;
import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.graphics.Color;
import android.os.Bundle;
import android.view.Gravity;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.view.Window;
import android.widget.AdapterView;
import android.widget.BaseAdapter;
import android.widget.GridView;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;
import java.util.ArrayList;

//z[XN[
public class HomeEx extends Activity 
    implements AdapterView.OnItemClickListener { 
    private final static int FP=LinearLayout.LayoutParams.FILL_PARENT;
    private ArrayList<AppInfo> appInfos;   //AvQ
    private BroadcastReceiver  appReceiver;//Avo^V[o[
    private GridView           gridView;   //Obhr[
        
    //ANeBreBNɌĂ΂
    @Override
    public void onCreate(Bundle bundle) {
        super.onCreate(bundle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        //CAEg̐
        LinearLayout layout=new LinearLayout(this);
        layout.setOrientation(LinearLayout.VERTICAL);
        setContentView(layout); 

        //Obhr[̐(1)
        gridView=new GridView(this);
        gridView.setBackgroundColor(Color.argb(200,0,0,0));
        gridView.setLayoutParams(new LinearLayout.LayoutParams(FP,FP));
        gridView.setNumColumns(4);
        gridView.setOnItemClickListener(this);
        gridView.setVisibility(View.INVISIBLE);
        layout.addView(gridView);
        
        //AvQ̓ǂݍ
        appInfos=AppInfo.readAppInfos(this);
        gridView.setAdapter(new GridAdapter());

        //Avo^V[o[̊Jn(5)
        IntentFilter filter=
            new IntentFilter(Intent.ACTION_PACKAGE_ADDED);
        filter.addAction(Intent.ACTION_PACKAGE_REMOVED);
        filter.addAction(Intent.ACTION_PACKAGE_CHANGED);
        filter.addDataScheme("package");
        appReceiver=new AppReceiver();
        registerReceiver(appReceiver,filter);        
    }   

    //ObhACẽNbNCxg
    public void onItemClick(AdapterView<?> parent,View v,int position,long id) {
        try {
            //ANeBreB̋N(7)
            AppInfo appInfo=appInfos.get(position);
            Intent intent=new Intent(Intent.ACTION_MAIN);
            intent.addCategory(Intent.CATEGORY_LAUNCHER);
            intent.setComponent(new ComponentName(
                appInfo.packageName,appInfo.className));
            intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK|
                Intent.FLAG_ACTIVITY_RESET_TASK_IF_NEEDED);
            startActivity(intent);
        } catch (Exception e) {
        }
    }    

    //ANeBreBɌĂ΂
    @Override
    public void onDestroy() {
        super.onDestroy();
        
        //Avo^V[o[̉
        unregisterReceiver(appReceiver);
    }    
    
    //obNL[̖(6)
    @Override
    public boolean dispatchKeyEvent(KeyEvent event) {
        if (event.getAction()==KeyEvent.ACTION_DOWN) {
            switch (event.getKeyCode()) {
                case KeyEvent.KEYCODE_BACK:
                    gridView.setVisibility(View.INVISIBLE);
                    return true;
            }
        }
        return super.dispatchKeyEvent(event);
    }

    //ObhA_v^̐(2)
    public class GridAdapter extends BaseAdapter {
        //ڐ̎擾
        public int getCount() {
            return appInfos.size();
        }

        //ڂ̎擾
        public Object getItem(int position) {
            return appInfos.get(position);
        }

        //ID̎擾
        public long getItemId(int position) {
            return position;
        }

        //r[̎擾
        public View getView(int position,View convertView,ViewGroup parent) {
            Context context=HomeEx.this;
            AppInfo appInfo=appInfos.get(position);
            
            //CAEg
            LinearLayout layout=new LinearLayout(context);
            layout.setOrientation(LinearLayout.VERTICAL);
            layout.setGravity(Gravity.CENTER_HORIZONTAL|Gravity.TOP);
            layout.setPadding(4,4,4,4);
            
            //ACR
            ImageView imageView=new ImageView(context);
            imageView.setImageDrawable(appInfo.icon);
            imageView.setLayoutParams(new LinearLayout.LayoutParams(72,72));
            layout.addView(imageView);
            
            //eLXgr[
            TextView textView=new TextView(context);
            textView.setLines(2);
            textView.setTextSize(12);
            textView.setGravity(Gravity.CENTER_HORIZONTAL);
            textView.setTextColor(Color.WHITE);
            textView.setText(appInfo.name);
            layout.addView(textView);
            return layout;
        }
    }

    //Avo^V[o[(5)
    private class AppReceiver extends BroadcastReceiver {
        @Override
        public void onReceive(Context context,Intent intent) {
            //AvXg̓ǂݍ
            appInfos=AppInfo.readAppInfos(HomeEx.this);
            gridView.setAdapter(new GridAdapter());
        }
    }
    
    //IvVj[̐
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        super.onCreateOptionsMenu(menu);
        MenuItem item0=menu.add(0,0,0,"ݒ");
        item0.setIcon(android.R.drawable.ic_menu_preferences);
        MenuItem item1=menu.add(0,1,0,"ǎ");
        item1.setIcon(android.R.drawable.ic_menu_gallery);
        MenuItem item2=menu.add(0,2,0,"`[");
        item2.setIcon(android.R.drawable.ic_menu_today);
        return true;
    } 
    
    //IvVj[ɌĂ΂
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        Intent intent;
        switch (item.getItemId()) {
            case 0:
                intent=new Intent("android.settings.SETTINGS");
                startActivity(intent);
                return true;
            case 1:
                //ǎ̕ύX(8)
                intent=new Intent(Intent.ACTION_SET_WALLPAPER);
                startActivity(Intent.createChooser(intent,"ǎI"));
                return true;
            case 2:
                gridView.setVisibility(View.VISIBLE);
                return true;
        }
        return true;
    }
}