package net.npaka.livewallpaperex;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Color;
import android.os.Handler;
import android.service.wallpaper.WallpaperService;
import android.view.SurfaceHolder;
import android.content.res.Resources;

//CuEH[y[p[̗p
public class LiveWallpaperEx extends WallpaperService {//(1)
    //ANeBreBNɌĂ΂
    @Override
    public void onCreate() {
        super.onCreate();
    }

    //ANeBreBjɌĂ΂
    @Override
    public void onDestroy() {
        super.onDestroy();
    }

    //EH[y[p[GWɌĂ΂(1)
    @Override
    public WallpaperService.Engine onCreateEngine() {
        return new WallpaperEngine(getResources());
    }

    //EH[y[p[GW
    public class WallpaperEngine extends WallpaperService.Engine {
        private final Handler handler=new Handler();        

        private Bitmap image;//C[W
        private int    px=0; //XW
        private int    py=0; //YW
        private int    vx=10;//Xx
        private int    vy=10;//Yx

        private boolean visible;//\
        private int     width;  //
        private int     height; //

        //`Xbh
        private final Runnable drawThread=new Runnable() {
            public void run() {
                drawFrame();
            }
        };

        //RXgN^
        public WallpaperEngine(Resources r) {
            image=BitmapFactory.decodeResource(r,R.drawable.sample);
        }
        
        //ANeBreBNɌĂ΂
        @Override
        public void onCreate(SurfaceHolder surfaceHolder) {
            super.onCreate(surfaceHolder);
        }

        //ANeBreBjɌĂ΂
        @Override
        public void onDestroy() {
            super.onDestroy();
            handler.removeCallbacks(drawThread);
        }

        //\ԕύXɌĂ΂
        @Override
        public void onVisibilityChanged(boolean visible) {
            this.visible=visible;
            if (visible) {
                drawFrame();
            } else {
                handler.removeCallbacks(drawThread);
            }
        }

        //T[tFCXɌĂ΂
        @Override
        public void onSurfaceCreated(SurfaceHolder holder) {
            super.onSurfaceCreated(holder);
        }

        //T[tFCXύXɌĂ΂
        @Override
        public void onSurfaceChanged(SurfaceHolder holder,
            int format,int width,int height) {
            super.onSurfaceChanged(holder,format,width,height);
            this.width =width;
            this.height=height;
            drawFrame();
        }

        //T[tFCXjɌĂ΂
        @Override
        public void onSurfaceDestroyed(SurfaceHolder holder) {
            super.onSurfaceDestroyed(holder);
            visible=false;
            handler.removeCallbacks(drawThread);
        }

        //ItZbgύXɌĂ΂
        @Override
        public void onOffsetsChanged(float xOffset,float yOffset,
            float xStep,float yStep,int xPixels,int yPixels) {
            drawFrame();
        }

        //t[̕`
        private void drawFrame() {
            //bN
            SurfaceHolder holder=getSurfaceHolder();
            Canvas c=holder.lockCanvas();

            //`
            c.drawColor(Color.WHITE);
            c.drawBitmap(image,px-57,py-57,null);

            //AbN
            holder.unlockCanvasAndPost(c);
                    
            //ړ
            if (px<0 || width <px) vx=-vx;
            if (py<0 || height<py) vy=-vy;
            px+=vx;
            py+=vy;
                
            //ĕ`
            handler.removeCallbacks(drawThread);
            if (visible) handler.postDelayed(drawThread,100);
        }
    }
}