package net.npaka.sensorex;
import android.app.Activity;
import android.content.Context;
import android.os.Bundle;
import android.graphics.Color;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.view.Window;
import android.widget.LinearLayout;
import android.widget.TextView;
import java.util.List;

//xZT[̗p
public class SensorEx extends Activity 
    implements SensorEventListener {
    private final static int WC=LinearLayout.LayoutParams.WRAP_CONTENT;
    private final static float FILTERING=0.1f;
    private TextView      textView;     //eLXgr[
    private SensorManager sensorManager;//ZT[}l[W
    private Sensor        accelerometer;//xZT[
    private Sensor        orientation;  //]ZT[
    private float[] values=new float[6];//xƌXl

    //ANeBreBNɌĂ΂
    @Override
    public void onCreate(Bundle bundle) {
        super.onCreate(bundle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        //CAEg̐
        LinearLayout layout=new LinearLayout(this);
        layout.setBackgroundColor(Color.rgb(255,255,255));
        layout.setOrientation(LinearLayout.VERTICAL);
        setContentView(layout); 

        //eLXgr[̐
        textView=new TextView(this);
        textView.setText("SensorEx");
        textView.setTextSize(24.0f);
        textView.setTextColor(Color.rgb(0,0,0));
        textView.setLayoutParams(new LinearLayout.LayoutParams(WC,WC));
        layout.addView(textView);
        
        //ZT[}l[W̎擾(1)
        sensorManager=(SensorManager)getSystemService(
            Context.SENSOR_SERVICE);
        
        //ZT[̎擾(2)
        List<Sensor> list;
        list=sensorManager.getSensorList(Sensor.TYPE_ACCELEROMETER);
        if (list.size()>0) accelerometer=list.get(0);
        list=sensorManager.getSensorList(Sensor.TYPE_ORIENTATION);
        if (list.size()>0) orientation=list.get(0);
    }

    //ANeBreBĊJɌĂ΂
    @Override
    protected void onResume() {
        super.onResume();
        
        //ZT[̏̊Jn(3)
        if (accelerometer!=null) {
            sensorManager.registerListener(this,accelerometer,
                SensorManager.SENSOR_DELAY_NORMAL);
        }
        if (orientation!=null) {
            sensorManager.registerListener(this,orientation,
                SensorManager.SENSOR_DELAY_NORMAL);
        }
    }
    
    //ANeBreB~ɌĂ΂
    @Override
    protected void onStop() {
        //Av̒~
        super.onStop();

        //ZT[̏̒~(4)
        sensorManager.unregisterListener(this);
    }
    
    //ZT[Xi[̏(5)
    public void onSensorChanged(SensorEvent event) {
        //x̎擾
        if (event.sensor==accelerometer) {
            values[0]=(event.values[0]*FILTERING)+(values[0]*(1.0f-FILTERING));
            values[1]=(event.values[1]*FILTERING)+(values[1]*(1.0f-FILTERING));
            values[2]=(event.values[2]*FILTERING)+(values[2]*(1.0f-FILTERING));
        }
        //̎擾
        if (event.sensor==orientation) {
            values[3]=(event.values[0]*FILTERING)+(values[3]*(1.0f-FILTERING));
            values[4]=(event.values[1]*FILTERING)+(values[4]*(1.0f-FILTERING));
            values[5]=(event.values[2]*FILTERING)+(values[5]*(1.0f-FILTERING));
        }
        //\
        String text="SensorEx"+
            "\nXx:"+(int)values[0]+
            "\nYx:"+(int)values[1]+
            "\nZx:"+(int)values[2]+
            "\n:"    +(int)values[3]+
            "\nsb`:"  +(int)values[4]+
            "\n[:"  +(int)values[5];
        textView.setText(text);
    }

    //xύXCxg̏
    public void onAccuracyChanged(Sensor sensor,int accuracy) {
    }
}