package net.npaka.actiongame;
import java.util.Random;
import android.content.*;
import android.graphics.*;
import android.view.*;

//ANVQ[
public class ActionView extends SurfaceView 
    implements SurfaceHolder.Callback,Runnable {
    //V[萔(1)
    private final static int 
        S_TITLE   =0,
        S_PLAY    =1,
        S_GAMEOVER=2;
    
    //VXe
    private SurfaceHolder holder;
    private Thread        thread;
    private Bitmap[]      bmp=new Bitmap[4];
    private boolean       touchDown;
    
    //V[
    private int    scene  =S_TITLE;//V[(1)
    private int    init   =S_TITLE;//(1)
    private String message=null;   //bZ[W
    private int    score  =0;      //XRA
    
    //vC[(3)
    private int     playerY; //YW
    private int     jumpPow; //Wv
    private boolean jumpAble;//Wv

    //n(2)
    private int   mapDX;           //XΈʒu
    private int[] mapH=new int[10];//
    
    //RXgN^
    public ActionView(Context context) {
        super(context);
        
        //rbg}bv̓ǂݍ
        for (int i=0;i<4;i++) bmp[i]=readBitmap(context,"r"+i);
        
        //T[tFCXz_[̐
        holder=getHolder();
        holder.addCallback(this);
        holder.setFixedSize(800,480);
    }
    
    //T[tFCXɌĂ΂
    public void surfaceCreated(SurfaceHolder holder) {
        init=S_TITLE;
        thread=new Thread(this);
        thread.start();
    }

    //T[tFCXIɌĂ΂
    public void surfaceDestroyed(SurfaceHolder holder) {
        thread=null;
    }

    //T[tFCXύXɌĂ΂
    public void surfaceChanged(SurfaceHolder holder,
        int format,int w,int h) {
    }   
    
    //Xbh̏
    public void run() {
        Canvas canvas;
        Paint  paint=new Paint();
        while(thread!=null) {
            //
            if (init>=0) {
                scene=init;
                init=-1;
                //^Cg
                if (scene==S_TITLE) {
                    message ="Touch Start";
                    score   =0;
                    playerY =380;
                    jumpPow =0;
                    jumpAble=true;
                    mapDX   =0;
                    for (int i=0;i<10;i++) mapH[i]=1;
                } 
                //vC
                else if (scene==S_PLAY) {
                    message  =null;
                    touchDown=false;
                } 
                //Q[I[o[
                else if (scene==S_GAMEOVER) {
                    message="Game Over";
                }
            }
            
            //vC̏
            if (scene==S_PLAY) {
                //XRAZ
                score++;

                //Փ˔
                if (playerY>480-mapH[2]*100) {
                    init=S_GAMEOVER;
                    jumpAble=false;
                }
                //ړ
                else if (jumpPow>=0) {
                    playerY-=jumpPow*2;
                    jumpPow--;
                }
                //ړ
                else {
                    playerY+=12;
                    jumpAble=false;
                    if (mapH[2]!=0 &&
                        playerY>480-mapH[2]*100) {
                        playerY=480-mapH[2]*100;
                        jumpAble=true;
                    }
                }
                //XN[(2)
                mapDX-=10;
                if (mapDX==-100) {
                    mapDX=0;

                    //nʂ̍ɃVtg
                    System.arraycopy(mapH,1,mapH,0,9);

                    //nʂ̍w
                    int idx=rand(6);
                    if (mapH[8]==0) {
                        mapH[9]=mapH[7];
                    } else if (idx==0) {
                        mapH[9]=0;
                    } else if (idx==1) {
                        mapH[9]=mapH[8]+1;
                        if (mapH[9]>4) mapH[9]=4;
                    } else if (idx==2) {
                        mapH[9]=mapH[8]-1;
                        if (mapH[9]<1) mapH[9]=1;
                    }
                }

                //Cxg
                if (jumpAble) {
                    if (touchDown) {
                        jumpAble=false;
                        jumpPow =14;
                    }
                } else {
                    if (!touchDown) {
                        jumpPow=-10;
                    }
                }
            }
            //Q[I[o[̏
            else if (scene==S_GAMEOVER) {
                if (playerY<700) playerY+=16;
            }
            
            //wi̕`
            canvas=holder.lockCanvas();
            canvas.drawBitmap(bmp[0],0,0,null);
            
            //vC[̕`
            int idx=3;
            if (jumpAble) idx=2+score%2;
            canvas.drawBitmap(bmp[idx],150,playerY-100,null);

            //nʂ̕`
            for (int i=0;i<mapH.length;i++) {
                canvas.drawBitmap(bmp[1],mapDX+i*100,
                    480-mapH[i]*100,null);
            }
            
            //XRA̕`
            paint.setColor(Color.WHITE);
            paint.setTextSize(30);
            canvas.drawText("SCORE "+num2str(score,6),10,40,paint);
            
            //bZ[W̕`
            if (message!=null) {
                canvas.drawText(message,
                    (800-paint.measureText(message))/2,100,paint);
            }
            holder.unlockCanvasAndPost(canvas);
            
            //X[v
            try {
                Thread.sleep(50);
            } catch (Exception e) {
            }
        }
    }
    
    //^b`Cxg̏
    @Override
    public boolean onTouchEvent(MotionEvent event) {
        int action=event.getAction();
        switch (action&MotionEvent.ACTION_MASK) {
            case MotionEvent.ACTION_DOWN:
                if (scene==S_TITLE) {
                    init=S_PLAY;
                } else if (scene==S_PLAY) {
                    touchDown=true;
                } else {
                    if (playerY>=700) init=S_TITLE;
                }
                break;
            case MotionEvent.ACTION_UP:
                if (scene==S_PLAY) {
                    touchDown=false;
                }
                break;
        }
        return true;
    }
    
    //̎擾
    private static Random rand=new Random();
    private static int rand(int num) {
        return (rand.nextInt()>>>1)%num;
    }
    
    //l
    private static String num2str(int num,int len) {
        String str=""+num;
        while(str.length()<len) str="0"+str;
        return str;
    }
    
    //rbg}bv̓ǂݍ
    private static Bitmap readBitmap(Context context,String name) {
        int resID=context.getResources().getIdentifier(
            name,"drawable",context.getPackageName());
        return BitmapFactory.decodeResource(
            context.getResources(),resID);
    }
}